
; ========================================================
;			
;    -- GLmacros.inc --
;			- Savage
; ========================================================
  static MACRO args
  	.data
  		args
  	.code
  ENDM

	$String MACRO sTEXT
		LOCAL szText
		.data
		 szText db sTEXT, 0
		.code
		EXITM <Offset szText>
	ENDM
	$f MACRO fNum
		LOCAL cNum
		.data
		 cNum REAL4 fNum
		.code
		EXITM <Offset cNum>
	ENDM
	$d MACRO dNum
		LOCAL cNum
		.data
		 cNum REAL8 dNum
		.code
		EXITM <Offset cNum>
	ENDM
	
	
	
	
	$ConstString MACRO sTEXT
		LOCAL szText
		.const
		 szText db sTEXT, 0
		.code
		EXITM <Offset szText>
	ENDM
	
	;; Note: I made this one flexible.  If you type a string instead of a number,
	;;  	It will use the ConstString macro.  Although I really can't make
	;;	string constants unique =X.  

	$Const MACRO Num, cType:=<DWORD>
	
		IFIDN @SubStr(<Num>,1,1),<">
		IFIDN @SubStr(<Num>,@SizeStr(<Num>),1),<">
			EXITM <$ConstString(Num)>
		ENDIF
		ENDIF
		
		IFIDN @SubStr(%Num,1,1),<->
			result textequ @CatStr(<__c_>,<cType>,<_>,@SubStr(<Num>,2))
		ELSE
			result textequ @CatStr(<_c_>,<cType>,<_>,<Num>)
	 	ENDIF
	 	
		%IFNDEF result
		  .const 
		    result cType Num
		  .code
	 	ENDIF
	 	
		EXITM <result>
	ENDM
	
	$fConst MACRO Num
	 	IFIDN @SubStr(<Num>,1,1),<->
	 		dotposition equ @InStr(2,<Num>,<.>)
			formatted textequ @CatStr(<_c_REAL4_>,@SubStr(<Num>,1,dotposition-1),<_>,@SubStr(<Num>,dotposition+1))   
	 		sgnlocation equ @InStr(1,%formatted,<->)
	 		formatted textequ @CatStr(<_>,@SubStr(%formatted,1,sgnlocation-1),@SubStr(%formatted,sgnlocation+1))   
	 	ELSE
	 		dotposition equ @InStr(2,<Num>,<.>)
			formatted textequ @CatStr(<c_REAL4_>,@SubStr(<Num>,1,dotposition-1),<_>,@SubStr(<Num>,dotposition+1))   
	 	ENDIF
		%IFNDEF formatted
		  .const 
		    formatted REAL4 Num
		  .code
	 	ENDIF
		EXITM <formatted>
	ENDM
	
	$dConst MACRO Num
	 	IFIDN @SubStr(<Num>,1,1),<->
	 		dotposition equ @InStr(2,<Num>,<.>)
			formatted textequ @CatStr(<_c_REAL8_>,@SubStr(<Num>,1,dotposition-1),<_>,@SubStr(<Num>,dotposition+1))   
	 		sgnlocation equ @InStr(1,%formatted,<->)
	 		formatted textequ @CatStr(<_>,@SubStr(%formatted,1,sgnlocation-1),@SubStr(%formatted,sgnlocation+1))   
	 	ELSE
	 		dotposition equ @InStr(2,<Num>,<.>)
			formatted textequ @CatStr(<c_REAL8_>,@SubStr(<Num>,1,dotposition-1),<_>,@SubStr(<Num>,dotposition+1))   
	 	ENDIF
		%IFNDEF formatted
		  .const 
		    formatted REAL8 Num
		  .code
	 	ENDIF
		EXITM <formatted>
	ENDM
	
	; This macro helps differentiate between numbers and variables
	$float MACRO val
		IF @InStr(1,<val>,<.>)
			EXITM <$fConst(val)>
		ELSE
			EXITM <val>
		ENDIF
	ENDM
	; This macro helps differentiate between numbers and variables
	$GetD MACRO val
		IF @InStr(1,<val>,<.>)
			EXITM <$dConst(val)>
		ELSE
			EXITM <val>
		ENDIF
	ENDM
	
	m2m MACRO dest,src
	  push src
	  pop dest
	ENDM
	
	m3m MACRO dest,src
	  mov eax, src
	  mov dest, eax
	ENDM
	

	
	
	;---------------------------------------------------------------------------
	; DrawGLScene Macros
	;---------------------------------------------------------------------------

	; Color 0.0, 1.0, 0.0
		Color  MACRO cRed,cGreen,cBlue
			invoke glColor3f,  $fConst(cRed),$fConst(cGreen),$fConst(cBlue)
		ENDM	
	; Vertex -1.0,-1.0, 1.0
		Vertex MACRO vX,vY,vZ
			invoke glVertex3f, $fConst(vX),  $fConst(vY),    $fConst(vZ)
		ENDM
	; Translate 0.0, 0.0,-5.0
		Translate MACRO tX,tY,tZ
		
			invoke glTranslatef, $float(tX), $float(tY), $float(tZ)	
			;invoke glTranslatef, $fConst(tX), $fConst(tY), $fConst(tZ)		
		ENDM
	; Rotate zrot, 0.0, 0.0, 1.0
		Rotate MACRO angle,rX,rY,rZ
			invoke glRotatef,$float(angle),$float(rX),$float(rY),$float(rZ)
		ENDM
	; ColorVertex 0.0, 1.0, 0.0,   -1.0,-1.0, 1.0
		ColorVertex MACRO cRed,cGreen,cBlue,vX,vY,vZ
			Color cRed,cGreen,cBlue
			Vertex vX,vY,vZ
		ENDM

	; TranslateRotate 0.0, 0.0,-5.0,    zrot, 0.0, 0.0, 1.0
		TranslateRotate MACRO tX,tY,tZ, angle,rX,rY,rZ
			invoke glLoadIdentity
			Translate tX,tY,tZ
			Rotate angle,rX,rY,rZ
		ENDM
	; TextCoord 1.0, 0.0
		TextCoord MACRO x,y
			invoke glTexCoord2f,$float(x),$float(y)	
		ENDM
	; TextureVertex 1.0, 0.0, -1.0,-1.0, 1.0
		TextureVertex MACRO x,y, vX,vY,vZ
			TextCoord x,y
			Vertex vX, vY, vZ
		ENDM